import { Component, OnInit, AfterViewInit, HostListener } from "@angular/core";
import { ToolService } from 'src/app/services/tool.service';
import { MainService } from 'src/app/services/main.service';

@Component({
  selector: "app-washing-batch-view",
  templateUrl: "./washing-batch-view.component.html",
  styleUrls: ["./washing-batch-view.component.less"],
})
export class WashingBatchViewComponent implements OnInit, AfterViewInit {
  constructor(
    public tool: ToolService,
    private mainService: MainService,
  ){}

  ngOnInit() {
    this.hosId = this.tool.getCurrentHospital().id;
    this.getParentList();
    this.getChildList();
  }

  ngAfterViewInit(){
    this.resizeInit();
  }
  _timer = null;
  @HostListener('window:resize')
  resizeInit(){
    clearTimeout(this._timer);
    this._timer = setTimeout(() => {
      this.scrollY = window.innerHeight - 206 - document.querySelector('.head').clientHeight - document.querySelector('th').clientHeight;
    }, 500)
  }

  listOfData: any[] = [
    ['眼科康复科睡', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
    ['大势科室', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18.05],
  ]; //表格数据
  loading:boolean = false;
  isAllDisplayDataChecked = false; //当前页是否全选
  mapOfCheckedId: { [key: string]: boolean } = {};
  checkedDepIds = []; //已选中单列id
  scrollY:number = 0;
  hosId:any;
  searchDto:any = {
    parent: null,
  }
  parentList: Array<any> = []; //父级分类数据字典信息
  childList: Array<any> = []; //分类数据字典信息
  rows:any[] = ['', '双单', '洗手衣上', '大包布', '中包布', '隔离衣', '无菌巾', '小洞巾', '大洞巾', '小毛巾', '病员服', '仪器套', '裤腿', '床套', '沙发套', '窗帘', '隔帘', '浴巾', '件数', '费用/元'];

  // 全选
  checkAll(value: boolean): void {
    this.listOfData.forEach((item) => {
      this.mapOfCheckedId[item.id] = value;
    });
    this.refreshStatus();
  }

  // 单选
  refreshStatus(): void {
    this.isAllDisplayDataChecked = this.listOfData.every(
      (item) => this.mapOfCheckedId[item.id]
    );
    let arr = [];
    for (var k in this.mapOfCheckedId) {
      if (this.mapOfCheckedId[k]) {
        arr.push(Number(k));
      }
    }
    this.checkedDepIds = arr;
  }

  // 整行操作
  selectedListData(data) {
    this.mapOfCheckedId[data.id] = !this.mapOfCheckedId[data.id];
    this.refreshStatus();
  }

  // 获取父级分类
  getParentList() {
    let postData = {
      idx: 0,
      sum: 9999,
      dictionaryTree: {
        hosId: this.hosId,
        level: 1,
        key: 'clothes_type',
        deleted: 0,
      },
    };
    this.mainService
      .getFetchDataList("simple/data", "dictionaryTree", postData)
      .subscribe((result) => {
        if(result.status == 200){
          this.parentList = result.list || [];
        }
      });
  }

  // 获取分类
  getChildList() {
    let postData = {
      idx: 0,
      sum: 9999,
      dictionaryTree: {
        hosId: this.hosId,
        level: 2,
        key: 'clothes_type',
        deleted: 0,
      },
    };
    this.mainService
      .getFetchDataList("simple/data", "dictionaryTree", postData)
      .subscribe((result) => {
        if(result.status == 200){
          this.childList = result.list || [];
        }
      });
  }
}

